"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequiredValidation = void 0;
var Command_1 = require("../../Patterns/CommandQuery/Command");
var RequiredValidation = /** @class */ (function () {
    function RequiredValidation(member, customErrorMessage) {
        this.member = member;
        this.customErrorMessage = customErrorMessage;
    }
    RequiredValidation.prototype.Validate = function (object) {
        var _this = this;
        return new Command_1.Command(function () {
            var valueExists = object[_this.member] && object[_this.member]
                .toString().trim().length >= 1;
            if (!valueExists) {
                var label = object.LabelFor(_this.member);
                throw new Error(_this.customErrorMessage || "\"".concat(label, "\" is a required field."));
            }
        }).Execute();
    };
    return RequiredValidation;
}());
exports.RequiredValidation = RequiredValidation;
//# sourceMappingURL=RequiredValidation.js.map