import { IObservable } from './IObservable';
export declare abstract class BaseObservable<T> implements IObservable<T> {
    CurrentIssue?: T;
    protected subscribers: Map<string, (content?: T) => void>;
    protected active: boolean;
    abstract Publish(content?: T): void;
    Cancel(subscriptionId: string): void;
    Discontinue(): void;
    Reinstate(): void;
}
