import { Observable } from '../../Patterns/Observable/Observable';
import { LogEntry } from './LogEntry';
export declare class Logger {
    private static instance;
    static get Instance(): Logger;
    /**
     * All logs collected during the current application lifecycle
     */
    LogEntries: LogEntry[];
    /**
     * Observable that is published to upon logging a new entry
     */
    EntryLogged: Observable<LogEntry>;
    private constructor();
    /**
     * Log a new entry
     * @param entry
     */
    Log(entry: LogEntry): void;
}
