import { ISerializer } from './ISerializer';
/**
 * Deserializes raw json data into an instance of T
 * **Some conventions are necessary - see wiki for full details**
 * - No ***required*** constructor params
 * - Init all property values
 * - Array<T> / List<T> values must be initialized with a single instance inside
 */
export declare class JsonSerializer implements ISerializer {
    Deserialize<T>(t: {
        new (): T;
    }, data: any): T;
    private getInstanceKey;
    private cleanString;
    private propertyIsSimple;
    private propertyIsArrayOfObjects;
    private getValueFromSerializer;
    private getArrayValuesFromSerializer;
    private serializeSimpleField;
    private getSingleValue;
    private getArrayValue;
}
